﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Dashboard.aspx.cs" Inherits="PBIWebApp.Dashboard" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">

    <!-- Sign in -->
    <div><h1 style="border-bottom:solid; border-bottom-color: silver">Power BI: Embed a tile</h1>
        <asp:Panel ID="signinPanel" runat="server" Visible="true">     

            <asp:Panel ID="signInStatus" runat="server">
            <table>
            <tr>
                <td style="height: 20px"><b>Signed in as:</b></td>
            </tr>
            <tr>
                <td><asp:Label ID="userLabel" runat="server"></asp:Label></td>
            </tr>
            <tr>
                <td><b>Access Token:</b></td>
            </tr>
            <tr>
                <td><asp:TextBox ID="accessTokenTextbox" runat="server" Width="586px"></asp:TextBox></td>
            </tr>

            </table>
                </asp:Panel>
        </asp:Panel>   
    </div>

        <!-- Get dashboards -->


    <!-- Get datasets -->


    <!-- Get dashboards -->
    <div> 
        <asp:Panel ID="PanelDashboards" runat="server" Visible="true">
            <p><b class="step">Step 1</b>: Get dashboards from your account.</p>
            <table>

            <tr>
                <td><asp:Button ID="Button2" runat="server" OnClick="getDashboardsButton_Click" Text="Get Dashboards" /></td>
            </tr>
            <tr>  
                <td><asp:TextBox ID="tb_dashboardsResult" runat="server" Height="200px" Width="586px" TextMode="MultiLine" Wrap="False"></asp:TextBox></td>
            </tr>

        </table>
        </asp:Panel>
    </div>

    <!-- Get tiles -->
    <div> 
        <asp:Panel ID="TilesStep" runat="server" Visible="true">
            <p><b class="step">Step 2</b>: Get tiles from your dashboards.</p>
            <table>
                <tr><td>Enter a dashboard id from step 1:<asp:TextBox ID="inDashboardID" runat="server" TextMode="SingleLine" Wrap="false"></asp:TextBox></td></tr>

            <tr>
                <td><asp:Button ID="Button1" runat="server" OnClick="getTilesButton_Click" Text="Get Tiles" /></td>
            </tr>
            <tr>  
                <td><asp:TextBox ID="tb_tilesResult" runat="server" Height="200px" Width="1024px" TextMode="MultiLine" Wrap="False"></asp:TextBox></td>
            </tr>

        </table>
        </asp:Panel>
    </div>

        <!-- Embed Tile-->
    <div> 
        <asp:Panel ID="PanelEmbedTile" runat="server" Visible="true">
            <p><b class="step">Step 3</b>: Embed a tile</p>
            <table>
                <tr><td>Enter an embed url for a tile from Step 2 (starts with https://):
                    <input type="text" id="tb_EmbedURL" />
                    <%--<asp:TextBox ID="tb_EmbedURL" TextMode="SingleLine" runat="server" Wrap="false"></asp:TextBox></td></tr>--%>

            <tr>
                <td><%--<asp:Button ID="bEmbedTileAction" runat="server" Text="Embed Tile" />--%>
                    <input type="button" id="bEmbedTileAction" value="Embed Tile" />
                </td>
            </tr>
                <tr>
                    <td>
                        <iframe ID="iFrameEmbedTile" src="" height="1080px" width="1280px" frameborder="0" seamless></iframe>
                    </td>
                </tr>
            <tr>  
                <%--<td><asp:TextBox ID="TextBox2" runat="server" Height="200px" Width="1024px" TextMode="MultiLine" Wrap="False"></asp:TextBox></td>--%>
            </tr>

        </table>
        </asp:Panel>
            

    </div>

    <script type="text/javascript">

        window.onload = function () {
            // client side click to embed a selected tile.
            var el = document.getElementById("bEmbedTileAction");
            if (el.addEventListener) {
                el.addEventListener("click", updateEmbedTile, false);
            } else {
                el.attachEvent('onclick', updateEmbedTile);
            }

            //How to navigate from a Power BI Tile to the dashboard
            // listen for message to receive tile click messages.
            if (window.addEventListener) {
                window.addEventListener("message", receiveMessage, false);
            } else {
                window.attachEvent("onmessage", receiveMessage);
            }

            //How to handle server side post backs
            // handle server side post backs, optimize for reload scenarios
            // show embedded tile if all fields were filled in.
            var accessTokenElement = document.getElementById('MainContent_accessTokenTextbox');
            if (null !== accessTokenElement) {
                var accessToken = accessTokenElement.value;
                if ("" !== accessToken)
                    updateEmbedTile();
            }
        };

        var width = 500;
        var height = 500;

        //How to navigate from a Power BI Tile to the dashboard
        // The embedded tile posts message for click to parent window.  
        // Listen and handle as appropriate
        // The sample shows how to open the tile source.
        function receiveMessage(event) {
            if (event.data) {
                try {
                    messageData = JSON.parse(event.data);
                    if (messageData.event === "tileClicked") {
                        //Get IFrame source and construct dashboard url
                        iFrameSrc = document.getElementById(event.srcElement.iframe.id).src;
                        iframe = document.getElementById(event.srcElement.iframe.id);
                        var url = messageData.navigationUrl.substring(0, messageData.navigationUrl.indexOf("?"));
                        url = url.replace("reports", "reportEmbed?")
                        url = url.replace("?/", "?reportId=");
                        iframe.src = url;
                        // show the embedded report
                        iframe.onload = postActionLoadReport;
                        return;

                        //or, you might prefer you can open the dashboard page in another window
                        var dashboardId = iFrameSrc.split("dashboardId=")[1].split("&")[0];
                        //Get PowerBI service url
                        urlVal = iFrameSrc.split("/embed")[0] + "/dashboards/{0}";
                        urlVal = urlVal.replace("{0}", dashboardId);

                        window.open(urlVal);
                    }
                }
                catch (e) {
                    // In a production app, handle exception
                }
            }
        }
        // post the auth token to the iFrame. 
        function postActionLoadReport() {

            // get the access token.
            accessToken = '<%=Session["authResult"]==null? null: ((Microsoft.IdentityModel.Clients.ActiveDirectory.AuthenticationResult)Session["authResult"]).AccessToken%>';

            // return if no a
            if ("" === accessToken) return;

            var h = height;
            var w = width;

            // construct the push message structure
            var m = { action: "loadReport", accessToken: accessToken };
            message = JSON.stringify(m);

            // push the message.
            iframe = document.getElementById('iFrameEmbedTile');
            iframe.contentWindow.postMessage(message, "*");
        }

        // update embed tile
        function updateEmbedTile() {
            // check if the embed url was selected
            var embedTileUrl = document.getElementById('tb_EmbedURL').value;
            if ("" === embedTileUrl)
                return;

            // to load a tile do the following:
            // 1: set the url, include size.
            // 2: add a onload handler to submit the auth token
            iframe = document.getElementById('iFrameEmbedTile');
            // Example 1: demonstrate filtering
            //embedTileUrl += "&$filter=SalesTerritory/SalesTerritoryCountry eq 'Canada'&Reseller/BusinessType eq 'Warehouse'"
            // Example 2: resize the tile to custom width and height            
            //iframe.src = embedTileUrl + "&width=" + width + "&height=" + height;
            iframe.src = embedTileUrl;
            iframe.onload = postActionLoadTile;
        }


        // post the auth token to the iFrame. 
        function postActionLoadTile() {
            // get the access token.

            accessToken = '<%=Session["authResult"]==null? null: ((Microsoft.IdentityModel.Clients.ActiveDirectory.AuthenticationResult)Session["authResult"]).AccessToken%>';
            //accessToken = document.getElementById('MainContent_accessTokenTextbox').value;

            // return if no a
            if ("" === accessToken)
                return;

            var h = height;
            var w = width;

            // construct the push message structure
            var m = { action: "loadTile", accessToken: accessToken, height: h, width: w };
            message = JSON.stringify(m);

            // push the message.
            iframe = document.getElementById('iFrameEmbedTile');
            iframe.contentWindow.postMessage(message, "*");;
        }

    </script>

</asp:Content>
